# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NamespaceSelfLinkIdPrincipalsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'edit_groups': 'str',
        'edit_users': 'str',
        'owner_groups': 'str',
        'owner_users': 'str',
        'view_groups': 'str',
        'view_users': 'str'
    }

    attribute_map = {
        'edit_groups': 'editGroups',
        'edit_users': 'editUsers',
        'owner_groups': 'ownerGroups',
        'owner_users': 'ownerUsers',
        'view_groups': 'viewGroups',
        'view_users': 'viewUsers'
    }

    def __init__(self, edit_groups=None, edit_users=None, owner_groups=None, owner_users=None, view_groups=None, view_users=None):  # noqa: E501
        """NamespaceSelfLinkIdPrincipalsBody - a model defined in Swagger"""  # noqa: E501
        self._edit_groups = None
        self._edit_users = None
        self._owner_groups = None
        self._owner_users = None
        self._view_groups = None
        self._view_users = None
        self.discriminator = None
        if edit_groups is not None:
            self.edit_groups = edit_groups
        if edit_users is not None:
            self.edit_users = edit_users
        if owner_groups is not None:
            self.owner_groups = owner_groups
        if owner_users is not None:
            self.owner_users = owner_users
        if view_groups is not None:
            self.view_groups = view_groups
        if view_users is not None:
            self.view_users = view_users

    @property
    def edit_groups(self):
        """Gets the edit_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The edit_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._edit_groups

    @edit_groups.setter
    def edit_groups(self, edit_groups):
        """Sets the edit_groups of this NamespaceSelfLinkIdPrincipalsBody.


        :param edit_groups: The edit_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._edit_groups = edit_groups

    @property
    def edit_users(self):
        """Gets the edit_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The edit_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._edit_users

    @edit_users.setter
    def edit_users(self, edit_users):
        """Sets the edit_users of this NamespaceSelfLinkIdPrincipalsBody.


        :param edit_users: The edit_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._edit_users = edit_users

    @property
    def owner_groups(self):
        """Gets the owner_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The owner_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._owner_groups

    @owner_groups.setter
    def owner_groups(self, owner_groups):
        """Sets the owner_groups of this NamespaceSelfLinkIdPrincipalsBody.


        :param owner_groups: The owner_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._owner_groups = owner_groups

    @property
    def owner_users(self):
        """Gets the owner_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The owner_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._owner_users

    @owner_users.setter
    def owner_users(self, owner_users):
        """Sets the owner_users of this NamespaceSelfLinkIdPrincipalsBody.


        :param owner_users: The owner_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._owner_users = owner_users

    @property
    def view_groups(self):
        """Gets the view_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The view_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._view_groups

    @view_groups.setter
    def view_groups(self, view_groups):
        """Sets the view_groups of this NamespaceSelfLinkIdPrincipalsBody.


        :param view_groups: The view_groups of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._view_groups = view_groups

    @property
    def view_users(self):
        """Gets the view_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501


        :return: The view_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :rtype: str
        """
        return self._view_users

    @view_users.setter
    def view_users(self, view_users):
        """Sets the view_users of this NamespaceSelfLinkIdPrincipalsBody.


        :param view_users: The view_users of this NamespaceSelfLinkIdPrincipalsBody.  # noqa: E501
        :type: str
        """

        self._view_users = view_users

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NamespaceSelfLinkIdPrincipalsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NamespaceSelfLinkIdPrincipalsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
